#include <Wire.h>
#include <PVision.h>
#include <Mouse.h>
#include <Adafruit_NeoPixel.h>


#define PIN 52
#define NUM_LEDS 3
#define BRIGHTNESS 30
Adafruit_NeoPixel strip = Adafruit_NeoPixel(NUM_LEDS, PIN, NEO_RGB + NEO_KHZ400);
int k1,k2;

PVision ircam;
byte result;

int lastPosX,
    lastPosY,
    curPosX,
    curPosY,
    X=0,
    Y=0,
    wheel=0,
    i,j=0,k;
    


int rangeX = 3 , rangeY = 2;  // output range of X or Y movement; affects movement speed
int responseDelay = 5;     // response delay of the mouse, in ms

int xDistance,yDistance;


/*                                                    DIY
   0  1  2  3  4  5  6  7  8  9  a  b  c  d  e  f
00:          -- -- -- -- -- -- -- -- -- -- -- -- --
10: -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
20: -- 21 -- -- -- -- -- -- -- -- -- -- -- -- -- --
30: -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
40: -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
50: -- 51 -- -- -- -- -- -- 58 -- -- -- -- -- -- --
60: -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
70: -- -- -- -- -- -- -- --
*/

void setup()
{
  Serial.begin(115200);
  
  Wire.begin(); // set master mode
  Wire.setClock(400000);      // I2C frequency at 400 kHz
  
  ircam.init();
  Mouse.begin();

  strip.setBrightness(BRIGHTNESS);
  strip.begin();
  strip.show();  

    rainbow(10);

}

void loop()
{
//  neoBlink();
  
  result = ircam.read();

  if (result & BLOB4)   //---------------- Mouse Wheel
  {

  }



  if (result & BLOB3)   //---------------- Mouse Right_Click
    {
      Mouse.press(MOUSE_RIGHT);
      k++;
    strip.setPixelColor(2, strip.Color(0,0,50));
    strip.show();
    }
  else 
    {
      Mouse.release(MOUSE_RIGHT);
    strip.setPixelColor(2, strip.Color(0,0,0));
    strip.show();
    }


  if (result & BLOB2)   //----------------- Mouse Left_Click
    {
      Mouse.press(MOUSE_LEFT);
      k++;
 //     delay(12);
 //     Mouse.release(MOUSE_LEFT);
 //     j++;     
    strip.setPixelColor(1, strip.Color(0,50,0));
    strip.show();
    }
  else 
    {
       Mouse.release(MOUSE_LEFT);
   strip.setPixelColor(1, strip.Color(0,0,0));
   strip.show(); 
    }
    
//  if(j==12){delay(30);j=0;}

  if (result & BLOB1)   //----------------- Mouse Move
  {
    k++;
    
    curPosX = ircam.Blob1.X;
    curPosY = ircam.Blob1.Y;
    
    xDistance = (lastPosX - curPosX)*rangeX;
    yDistance = (lastPosY - curPosY)*rangeY;

//    X = xDistance/rangeX;
//    Y = yDistance/RangeY;
    
    lastPosX = curPosX;
    lastPosY = curPosY; 
    
/*
    Serial.print("X:");
    Serial.print(xDistance);
    Serial.print(" Y:");
    Serial.print(yDistance);
    Serial.print("    Z:");
    Serial.println(ircam.Blob1.Size);
*/
    strip.setPixelColor(0, strip.Color(50,0,0));
    strip.show();

    if ( k <= 2 )
    {
       if ( (xDistance != 0) || (yDistance != 0)) 
        {
          Mouse.move(-xDistance, -yDistance, 0);
          Mouse.move(0, 0, 0);  
        }         
    }  
   }
   else
   {
   strip.setPixelColor(0, strip.Color(0,0,0));
   strip.show(); 
   }

   strip.setPixelColor(2, strip.Color(0,0,0));
   strip.show(); 
   
  delay(responseDelay);
  k=0;


  /*
   // read the buttons:
  int upState = digitalRead(upButton);
  int downState = digitalRead(downButton);
  int rightState = digitalRead(rightButton);
  int leftState = digitalRead(leftButton);
  int clickState = digitalRead(mouseButton);

  // calculate the movement distance based on the button states:
  int  xDistance = (leftState - rightState) * range;
  int  yDistance = (upState - downState) * range;

  // if X or Y is non-zero, move:
  if ((xDistance != 0) || (yDistance != 0)) {
    Mouse.move(xDistance, yDistance, 0);
  }

  // if the mouse button is pressed:
  if (clickState == HIGH) {
    // if the mouse is not pressed, press it:
    if (!Mouse.isPressed(MOUSE_LEFT)) {
      Mouse.press(MOUSE_LEFT);
    }
  }
  // else the mouse button is not pressed:
  else {
    // if the mouse is pressed, release it:
    if (Mouse.isPressed(MOUSE_LEFT)) {
      Mouse.release(MOUSE_LEFT);
    }
  }

  // a delay so the mouse doesn't move too fast:
  delay(responseDelay);
  */
  

}



void neoBlink()
{
  
  if (i<0){strip.setPixelColor(1, strip.Color(0,150,0));strip.show();delay(150);}
  
  if (i<10)
  {
   k1 = map(i,0,10,0,100);
//   strip.setPixelColor(0, strip.Color(0,0,0)); // Moderately bright green color.
//   strip.setPixelColor(1, strip.Color(0,0,0));
   strip.setPixelColor(2, strip.Color(k1,100-k1,0));
   strip.show(); 
  }
    if (i>=10)
  {
  if(i>10) k1 = map(i,10,19,0,100);
  if(i>20) k1 = map(i,20,29,0,100);
  if(i>30) k1 = map(i,30,39,0,100);
  if(i>40) k1 = map(i,40,49,0,100);
  if(i>50) k1 = map(i,50,59,0,100);
  if(i>60) k1 = map(i,60,69,0,100);
  if(i>70) k1 = map(i,70,79,0,100);
  if(i>80) k1 = map(i,80,89,0,100);
  if(i>90) k1 = map(i,90,99,0,100);
  
   strip.setPixelColor(2, strip.Color(k1,100-k1,0));   
    
   k2 = map(i,0,100,0,100);
   strip.setPixelColor(1, strip.Color(k2,100-k2,0));
   
   //strip.setPixelColor(2, strip.Color(20,100,0));
   strip.show(); // This sends the updated pixel color to the hardware.
  }
    if (i>100)
  {
   strip.setPixelColor(0, strip.Color(50,0,0)); // Moderately bright green color.
   strip.setPixelColor(1, strip.Color(50,0,0));
   strip.setPixelColor(2, strip.Color(50,0,0));
   strip.show(); // This sends the updated pixel color to the hardware.
  }
  
   delay(50);
   
   strip.setPixelColor(0, strip.Color(0,0,0)); // Moderately bright green color.
   strip.setPixelColor(1, strip.Color(0,0,0));
   strip.setPixelColor(2, strip.Color(0,0,0));
   strip.show(); 
// This sends the updated pixel color to the hardware.

}









//###############################################################  
//###############################################################  

void rainbow(uint8_t wait) {
  uint16_t i, j;

  for(j=0; j<256; j++) {
    for(i=0; i<strip.numPixels(); i++) {
      strip.setPixelColor(i, Wheel((i+j) & 255));
    }
    strip.show();
    delay(wait);
  }
}

//###############################################################  
//###############################################################  

// Slightly different, this makes the rainbow equally distributed throughout

void rainbowCycle(uint8_t wait) {
  uint16_t i, j;

  for(j=0; j<256*5; j++) { // 5 cycles of all colors on wheel
    for(i=0; i< strip.numPixels(); i++) {
      strip.setPixelColor(i, Wheel(((i * 256 / strip.numPixels()) + j) & 255));
    }
    strip.show();
    delay(wait);
  }
}
//###############################################################  
//###############################################################  

//Theatre-style crawling lights.

void theaterChase(uint32_t c, uint8_t wait) {
  for (int j=0; j<10; j++) {  //do 10 cycles of chasing
    for (int q=0; q < 3; q++) {
      for (uint16_t i=0; i < strip.numPixels(); i=i+3) {
        strip.setPixelColor(i+q, c);    //turn every third pixel on
      }
      strip.show();

      delay(wait);

      for (uint16_t i=0; i < strip.numPixels(); i=i+3) {
        strip.setPixelColor(i+q, 0);        //turn every third pixel off
      }
    }
  }
}

//###############################################################  
//###############################################################  

//Theatre-style crawling lights with rainbow effect
void theaterChaseRainbow(uint8_t wait) {
  for (int j=0; j < 256; j++) {     // cycle all 256 colors in the wheel
    for (int q=0; q < 3; q++) {
      for (uint16_t i=0; i < strip.numPixels(); i=i+3) {
        strip.setPixelColor(i+q, Wheel( (i+j) % 255));    //turn every third pixel on
      }
      strip.show();

      delay(wait);

      for (uint16_t i=0; i < strip.numPixels(); i=i+3) {
        strip.setPixelColor(i+q, 0);        //turn every third pixel off
      }
    }
  }
}

//###############################################################  
//###############################################################  

// Input a value 0 to 255 to get a color value.
// The colours are a transition r - g - b - back to r.
uint32_t Wheel(byte WheelPos) {
  WheelPos = 255 - WheelPos;
  if(WheelPos < 85) {
    return strip.Color(255 - WheelPos * 3, 0, WheelPos * 3);
  }
  if(WheelPos < 170) {
    WheelPos -= 85;
    return strip.Color(0, WheelPos * 3, 255 - WheelPos * 3);
  }
  WheelPos -= 170;
  return strip.Color(WheelPos * 3, 255 - WheelPos * 3, 0);
}